/************************************************************************
 * 
 ************************************************************************
 */ 

#pragma once

static unsigned     cpu_frequency = -1;
unsigned __int64    initial_timestamp_counter;

#define GET_VENDOR_STRING(buffer)               \
{                                               \
    __asm   xor     eax, eax                    \
    __asm   cpuid                               \
    __asm   mov     dword ptr buffer[0], ebx    \
    __asm   mov     dword ptr buffer[4], edx    \
    __asm   mov     dword ptr buffer[8], ecx    \
    __asm   mov     byte ptr buffer[12], 0      \
}


#pragma warning(push)
#ifdef  __INTEL_COMPILER
#pragma warning(disable:1011)
#endif


inline unsigned __int64
get_timestamp_counter()
{
    __asm   rdtsc
}

inline void 
set_start_time()
{
    initial_timestamp_counter = get_timestamp_counter();
}

inline unsigned
get_time_from_start()
{
    __asm
    {   // BUGGY !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        //    
        //     .
        rdtsc
        sub     eax, dword ptr initial_timestamp_counter
        sbb     edx, dword ptr initial_timestamp_counter + 4
        div     cpu_frequency
    }
}

inline unsigned
determine_frequency()
{
    LARGE_INTEGER   performance_counter_1;
    LARGE_INTEGER   performance_counter_2;
    LARGE_INTEGER   performance_frequency;    
    unsigned int    timestamp_counter;

    QueryPerformanceFrequency(&performance_frequency);
    QueryPerformanceCounter(&performance_counter_1);
    __asm   rdtsc
    __asm   neg     eax
    __asm   mov     timestamp_counter, eax
    Sleep(20);
    QueryPerformanceCounter(&performance_counter_2);
    __asm
    {
        rdtsc
        add     timestamp_counter, eax
        //   QueryPerformanceCounter  :
        mov     eax, performance_counter_2.LowPart
        mov     edx, performance_counter_2.HighPart
        sub     eax, performance_counter_1.LowPart
        sbb     edx, performance_counter_1.HighPart
        mov     ecx, 1000000
        mul     ecx
        div     performance_frequency.LowPart
        //   = timestamp_counter / __rdtsc
        mov     ecx, timestamp_counter
        xor     edx, edx
        xchg    eax, ecx
        div     ecx
        mov     cpu_frequency, eax
    }
//    return cpu_frequency;
}

#pragma warning(pop)


// EOF
