
$columns = 5;

foreach $file (<*.bin>)
{
    print "\nProcessing file `$file'\n";
    open(SOURCE, $file) or die "Can't open file: $!";
    binmode(SOURCE);

    $file = lc($file); $file =~ s/.bin//;
    open(OUT, ">$file.cpp") or die "Can't open output file: $!";

    print OUT "/************************************************************************\n";
    print OUT " *\n";
    print OUT " ************************************************************************\n";
    print OUT " */\n\n\n";
                                       
    print OUT "namespace $file\n{\n";
    print OUT "    enum         { columns = $columns };\n\n";
    print OUT "    unsigned char  data [][columns] =\n    {\n";

    $column = 0;

    while( ! eof(SOURCE) )
    {
        ! $column++ and print OUT '        {'; 

        printf OUT "0x%02X",ord(getc(SOURCE));

        if( $column >= $columns or eof(SOURCE) )
        {
            print OUT "},\n";
            $column = 0;
        }
        else
        { 
            print OUT ", ";
        } 
    }
    print OUT "    };\n};\n";

    close(OUT);
    close(IN);
}
