/************************************************************************
 * 
 ************************************************************************
 */ 


static  unsigned    pattern [height][width/2];


void static inline
init_background_pattern()
{
    //  pattern[y][x] = 0x1000000/sqrt((float)(x-320)*(x-320)+(y-240)*(y-240));
    __asm
    {
        mov     edx, offset pattern
        mov     eax, height / 2
    py: push    eax
        mov     eax, width / 2  //ax
    px: push    eax
        fild    dword ptr[esp]
        fmul    st(0), st(0)
        fild    dword ptr[esp+4]
        fmul    st(0), st(0)
        faddp   st(1), st(0)
        fsqrt
        mov     dword ptr[edx], 0x1000000
        fidivr  dword ptr[edx]
        fistp   dword ptr[edx]
        add     edx, 4
        pop     eax
        dec     eax
        jnz     px
        pop     eax
        dec     eax
        cmp     eax, -height / 2
        jnz     py
    }
}


#pragma optimize( "O2t", on )       //   align
__declspec(naked) void __fastcall
paint_background(
                    ARGB  * memory, // ecx
                    long    pitch   // edx
    )
{
    static  LARGE_INTEGER   step;   // 2 dword'   
    __asm
    {
        ;// esp ,  exeption handler 
        ;//  !!!
        pushad
        mov     eax, offset step
        mov     [eax+4], esp
        sub     dword ptr[eax], 4
        mov     esi, offset pattern
        mov     ebp, height
        mov     esp, edx            ;// pitch
    ly:     
            mov     eax, step.LowPart
            sub     eax, ebp
            mov     edi, width/2
            and     eax, (sine_table_size-1)*4
            mov     ebx, ds:sine[eax]   ;//  -   lx
        lx:     mov     eax, [esi]
                add     esi, 4
                mul     ebx
                mov     eax, edx
                shl     edx, 9
                or      eax, edx
                shl     edx, 9
                or      eax, edx
                and     eax, 0xFEFEFF   ;//    = 0 -   .
                dec     edi
                mov     [ecx], eax
                lea     ecx, [ecx+4]
            jnz      lx
        lx2:    mov     eax, [ecx-8]
                mov     edx, [ecx-8+4]
                mov     [ecx+edi+8-4], eax
                mov     [ecx+edi+8-8], edx
                add     edi, 16
                sub     ecx, 8
                cmp     edi, width*4
            jnz     lx2         
            add     ecx, esp
            dec     ebp
        jnz     ly
        mov     esp, step.HighPart
        popad
        ret
    }
}
#pragma optimize( "", on )


// EOF
