/************************************************************************
 * 
 ************************************************************************
 */ 


//=========================================================================//
//  

                        //0000000000111111111
                        //0123456789012345678
char      * level_text = "LIVES:***  LEVEL:**";
enum      { lives_position = 8,
            level_position = 18 };
unsigned    lives, level;

                        //0000000000111111
                        //0123456789012345
char      * score_text = "GAME SCORE:*****";
enum      { score_position = 15 };
unsigned    score;


//=========================================================================//
// ""    ASCII 
void    inline  format_to_ascii(
        char   * string,    //   
                            //      ':' !!!
        unsigned number)               
{
    do
    {
        unsigned    remainder = number % 10;
        number /= 10;
        *string-- = remainder + '0';
    }
    while( *string != ':' );
}


//=========================================================================//
//    
void inline __fastcall
draw_border(ARGB * memory, long pitch, ARGB color)
{
    const frame   = 5;
    //     
    for(  unsigned i = vborder - frame; i; i-- )
    {
        ARGB * p = memory + width;
        do  *(ARGB *)((char *)p + (height-vborder+frame)*pitch) =
            *(--p) = 0;
        while( p > memory );
        memory = (ARGB *)((char *)memory + pitch);
    }
    //     .
    for(  unsigned i = frame; i; i--)
    {
        ARGB * p = memory + width;
        do  *(ARGB *)((char *)p + (height-2*vborder+frame)*pitch) =
            *(--p) = color;
        while( p > memory );
        memory = (ARGB *)((char *)memory + pitch);
    }
    //     .
    unsigned y = height - 2*vborder;
    do
    {
        ARGB * p = memory + frame;
        do  *p = (--p)[width - frame] = color;
        while( p > memory );
        memory = (ARGB *)((char *)memory + pitch);
    }
    while( --y );
}

