
$room_size = 120;
$columns = 6;

foreach $file (<*.bin>)
{
    print "\nProcessing file `$file'\n";
    open(SOURCE, $file) or die "Can't open file: $!";
    binmode(SOURCE);

    $file = lc($file); $file =~ s/.bin//;
    open(OUT, ">$file.cpp") or die "Can't open output file: $!";

    print OUT "/************************************************************************\n";
    print OUT " *\n";
    print OUT " ************************************************************************\n";
    print OUT " */\n\n\n";
                                       
    print OUT "namespace $file\n{\n";
    print OUT "    short data [][$room_size] =\n    {\n";

    $column = $room = 0; $level = 1;

    while( ! eof(SOURCE) )
    {
        ! $room++ and print OUT "        // level $level\n        {\n"; 
        ! $column++ and print OUT '            '; 

        printf OUT "0%05o",ord(getc(SOURCE))+0x100*ord(getc(SOURCE));

        if( $column >= $columns or eof(SOURCE) )
        {
            if( $room >= $room_size )
            {
                print OUT "\n        },\n";
                $room = 0; $level++;
            }
            else
            {
                print OUT ",\n";
            }
            $column = 0;
        }
        else
        { 
            print OUT ", ";
        } 
    }
    print OUT "    };\n    // end of data\n};\n";

    close(OUT);
    close(IN);
}
