/************************************************************************
 * 
 *  
 *    .
 * 
 ************************************************************************
 */ 

#pragma once

// 2   !!! -   draw_cell_bridge
// + 1 , ..   qword !!!
static  unsigned int    sine    [sine_table_size*2/*+1/*!*/];  


//   * 0xffffffff  a * sine_table_size * pi
unsigned inline qsin(unsigned a)
{
    return  sine[sine_table_size-1 & a];
}


void static inline
init_sine_table()
{
    //for( int a = 0; a < sin_table_size; a++ )
    //    sine[a] = 0xffffffff*(sin(PI*(float)a/sin_table_size));
    __asm
    {
        mov     edx, offset sine
        xor     eax, eax
        xor     ecx, ecx
        mov     ch, sine_table_size / 256
    l:  fldpi
        mov     dword ptr[edx], eax
        fimul   dword ptr[edx]
        mov     dword ptr[edx], ecx
        fidiv   dword ptr[edx]
        fsin
        or      dword ptr[edx], 0xffffffff
    //    and     dword ptr[edx+4], 0
        fild    qword ptr[edx]
        fmulp   st(1), st(0)
        fistp   qword ptr[edx]
        add     edx, 4
        inc     eax
        cmp     eax, ecx
        jc      l
    }
}


// EOF
