/************************************************************************
 * 
 ************************************************************************
 */ 


#include "gfx_char.cpp"


#define CCC_COLOR           "\x10"
#define CCC_COLOR_DEFAULT   "\x13"


ARGB * (__fastcall * draw_char)(ARGB *, long, char, ARGB) = font8x5::draw_char_X4H;

void __stdcall
draw_text(ARGB * memory, long pitch, char * text, ARGB color)
{
    ARGB * p = memory;  ARGB temp = color;
    while( true )
    {
        char character = *text++;
        switch( character )
        {
        case '\0':
            return;

        //  CCC_COLOR_DEFAULT
        case 0x13:
            temp = color;
            break;

        //  CCC_COLOR       !!!
        //         
        //  ' ' ... 0x7F -     .
        case 0x10:                  // 'A'   = 0x10 !!!
            temp = *(ARGB *)text;   //     ...
            text += sizeof(ARGB)-sizeof(char);
            break;

        case '\n':
            memory = p = draw_char(memory, pitch, character, 0);
            break;

        default:
            p = draw_char(p, pitch, character, temp);
        }
    }
}


