#
#  This silly script converts CPS files ("cacofony" compose into .cpp source)
#  

$C = '$C';
foreach $file (<*.$C>)
{
    print "\nProcessing file `$file'\n";
    open(SOURCE, $file) or die "Can't open file: $!";
    binmode(SOURCE);

    read SOURCE,$dummy,17;
    read SOURCE,$signature,16;

    if( $signature eq 'CACOFONY SC V0.0' )
    {
        $file = lc($file); $file =~ s/.\$c//;
        open(OUT, ">$file.cpp") or die "Can't open output file: $!";

        $dummy = getc(SOURCE);
        read SOURCE,$compose_name,15;
        print  "compose name : $compose_name\n";

        $dummy = getc(SOURCE);
        read SOURCE,$author,15;
        print "author       : $author\n";

        print OUT "/************************************************************************\n";
        print OUT " *\n";
        print OUT " * compose name : $compose_name\n";
        print OUT " *\n";
        print OUT " * author       : $author\n";
        print OUT " *\n";
        print OUT " ************************************************************************\n";
        print OUT " */\n\n\n";

        print OUT "unsigned char $file [] =\n{\n";

        $column = 0;

        while( ! eof(SOURCE) )
        {
            ! $column++ and print OUT '    "'; 

            printf OUT "\\x%02X",ord(getc(SOURCE));

            $column &= 0xF and ! eof(SOURCE) or print OUT "\"\n"; 
        }
        print OUT "};\n";
        close(OUT);
    }
    close(IN);
}
